function save_sequence(seq, dirPath)
% save_sequence(seq, dirPath)

if(dirPath(end ~= filesep))
    dirPath = [dirPath filesep];
end

numFrames = length(seq.frames);

format = [repmat('%.4f\t', 1, seq.camType.width) '\n'];

i = 1;
while(i <= numFrames)
    
    help = num2str(i);
    switch length(help)
        case 1
           help = ['000' help];
        case 2
           help = ['00' help];
        case 3
           help = ['0' help];
        otherwise ;
    end
    
    srMatrix = frame2srdat(seq.frames(i), seq.camType);
    
    file = fopen([dirPath 'frame_' help '.dat'], 'w');
    
    fprintf(file, '%s\n', '% Calibrated Distance');
    fprintf(file, format, srMatrix(1:seq.camType.height, :)');
    fprintf(file, '%s\n', '% Calibrated xVector');
    fprintf(file, format, srMatrix(seq.camType.height+1:2*seq.camType.height, :)');
    fprintf(file, '%s\n', '% Calibrated yVector');
    fprintf(file, format, srMatrix(2*seq.camType.height+1:3*seq.camType.height, :)');
    fprintf(file, '%s\n', '% Amplitude');
    fprintf(file, format, srMatrix(3*seq.camType.height+1:4*seq.camType.height, :)');
    fprintf(file, '%s\n', '% Usage');
    fprintf(file, format, srMatrix(4*seq.camType.height+1:end, :)');
    
    fclose(file);
    
    i = i+1;
    
end
