function [planes, rest, restIndx] = cluster2plane(cl,indx)
%% plane = cluster2plane(cl,indx)

if(~iscell(cl))
    disp('Error: Parameter "cl" has to be a cell array');
    return;
end

rest = [];
restIndx = [];

l = cellfun('size', cl, 2);
out = find(l < 3);

if(~isempty(out))
    rest = cl{out};
    restIndx = indx{out};
end

coeff = cellfun(@(x)(princomp(x')), cl, 'UniformOutput', false);

normal = cellfun(@(x)(x(:,3)), coeff, 'UniformOutput', false);

d = cellfun(@(x,y)(x'*mean(y,2)), normal, cl, 'UniformOutput', false);

help = [cl; indx; normal; d];
planes = cell2struct(help, ...
        {'pnts', 'indx', 'n', 'd'}, 1)';