function [clusters, rest, clustersIndx] = cluster_through_connectedPoints(fr, camProportion, display)
% clusters = cluster_through_connectedPoints(fr, camProportion, display)
%
% camProportion = pixelsize / focallength
% display: 1 - visualize clusters; 0 - no visulaization (optinal; default: 0)

if(nargin < 3)
    display = false;
end

if(nargin < 2)
    camProportion = 1;
end

usage = fr.usage;
pnts = fr.points3D;

clusters = [];
clustersIndx = [];
rest = [];

allIndx = usage;

i = 1;
while(~isempty(allIndx))
    
    clustersIndx{i} = []; %new cluster
    workingIndx = allIndx(1);
    allIndx(1) = [];
    
    while(~isempty(workingIndx))
        
        currIndx = workingIndx(1);
        workingIndx(1) =[];
        clustersIndx{i} = [clustersIndx{i} currIndx];
        
        if(isempty(allIndx)) continue; end
        
        threshold = 60;
        %threshold = 30;
        threshold = 2/100 * camProportion * pnts(3,currIndx);
        
        diff = pnts(1:3, allIndx) - repmat(pnts(1:3, currIndx), 1, length(allIndx));
        diff = sqrt(sum(diff.^2));
        
        pos = find(diff < threshold);
        
        workingIndx = [workingIndx allIndx(pos)];
        allIndx(pos) = [];
        
    end
    
    clusters{i} = pnts(1:3, clustersIndx{i});
    
    i = i+1;
    
end
        

% restPnts = pnts;
% workingSet = [];
% clusters = [];
% %threshold = 900;
% 
% i = 1;
% while(~isempty(restPnts))
%     
%     workingSet = restPnts(:,1);
%     restPnts(:,1) = [];
%     clusters{i} = []; % new cluster
%     
%     % find Points in restPnt-set that in the near neighborhood of the current
%     % point
%     while(~isempty(workingSet))
%         
%         % two neighboorhood pixels have a different absolute Eculidean distance.
%         % It depends on the distance of the real 3D points to the image plane of
%         % the camera (z-values):
%         % 2 * pixelsize / focallength * z-value
%         lR = size(restPnts, 2);
%         %threshold = (2 * camProportion * workingSet(3,1))^2;
%         threshold = 5;
%         currPnt = [workingSet(1,1) * ones(1, lR); ...
%             workingSet(2,1) * ones(1, lR) ; workingSet(3,1) * ones(1, lR)];
%         diff = restPnts - currPnt;
%         diff = diff.^2;
%         diff = sum(diff);
%         posNN = find(diff < threshold); % position of NN
%         
%         clusters{i} = [clusters{i} workingSet(:,1)]; % store current point in cluster
%         workingSet(:,1) = []; % remove current point from working set
%         workingSet = [workingSet restPnts(:, posNN)]; % store NN in working set
%         restPnts(:, posNN) = [];
%         
%     end
%     
%     i = i+1;
%     
% end

if(display)
    
    show_clusters(clusters, 0);
    
end
    
    