function plane = extract_plane_manually(pnts)

pntsIndx = [1:size(pnts,2)];

fig = figure;
fig = plot_3Dpoints(pnts, 'k', fig, 0.3);

dcm_obj = datacursormode(fig);

disp('Select 4 points determing the corners of the plane.');
input('Press enter if ready.');

initIndx = [];
i = 1;
while(i <= 4)
    
    set(dcm_obj, 'Enable', 'on');
    figure(fig);
    
    w = waitforbuttonpress;
    
    pInfo = getCursorInfo(dcm_obj);
    
    initIndx = [initIndx pInfo.DataIndex];
    fig = plot_3Dpoints(pnts(1:3,pInfo.DataIndex), 'r', fig);
    
    i = i+1;
    
end
    
initPlane.points = pnts(1:3, initIndx);
initPlane.indx = initIndx;

[coeff, score] = princomp(initPlane.points');

initPlane.normal = coeff(:,3);
initPlane.d = initPlane.normal' * mean(initPlane.points,2);
initPlane.points = initPlane.points - initPlane.normal * score(:,3)';
initPlane.center = mean(initPlane.points, 2);

plane = initPlane;

close(fig);

%initPlane.radius = max(sqrt(sum( ...
%    (initPlane.points - repmat(initPlane.center,1,size(initPlane.points,2))).^2)));

%indx = compute_pntsINrect(pnts, initPlane);
%
%clf(fig);
%fig = plot_3Dpoints(pnts(1:3,:), 'k', fig, 0.3);
%fig = plot_3Dpoints(pnts(1:3,indx), 'y', fig);


% dev = initPlane.normal'*pnts - initPlane.d;
% projPnts = pnts - initPlane.normal * dev;
%
% dis = sqrt(sum((projPnts - repmat(initPlane.center, 1, size(projPnts,2))).^2));
% 
% planeIndx = find(dis <= initPlane.radius & abs(dev) < 100);
% restIndx = pntsIndx;
% restIndx(planeIndx) = [];
% 
% clf(fig);
% fig = plot_3Dpoints(pnts(:,restIndx), 'k', fig, 0.3);
% fig = plot_3Dpoints(pnts(:, planeIndx), 'y', fig);
% 
% disp('Click on all points which should be removed.');
% disp('If you are ready enter press a key!');
% 
% rmvIndx = [];
% while(1)
%     
%     set(dcm_obj, 'Enable', 'on');
%     figure(fig);
%     
%     w = waitforbuttonpress;
%     
%     if(w) break; end
%     
%     pInfo = getCursorInfo(dcm_obj);
%     
%     rmvIndx = [rmvIndx pInfo.DataIndex];
%     fig = plot_3Dpoints(pnts(:,pInfo.DataIndex), 'c', fig);
%     
% end
% 
% rmvIndx


