function planes = frame_decompostion(frame, camType)
% regions = frame_decomposition(frame)

scrsz = get(0,'ScreenSize');

se = strel('square',5);
imDis = reshape(frame.points3D_org(3,:), camType.width, [])';
figure('Position', [1 scrsz(4)/2 scrsz(3)/2 scrsz(4)/2]);
imshow(imDis, []);
imDis = imerode(imdilate(imDis, se), se);
bwDis = edge(imDis, 'canny');
bwDis = imerode(imdilate(bwDis, se), se);

regions = region_growing(bwDis);
regionsVec = reshape(regions', 1, []);

bins = -2:1:max(max(regions));
n = histc(regionsVec, bins);
n = n(4:end);

[ns, ni] = sort(n, 'descend');

uRest = frame.usage;
plane = struct('points', [], 'n', [0; 0; 0], 'd', 0);
planes = [];

fig = figure('Position', [1 1 scrsz(3)/2 scrsz(4)/2]);
map = colormap('jet');

i=1;
while(i<=6)
    
    if(i<=length(ni))
        maxi = ni(i);
        ui = find(regionsVec == maxi);
        ui = ui(ismember(ui, frame.usage));
        
        uRest(ismember(uRest, ui)) = [];
        
        s{i} = frame.points3D_org(1:3, ui);
        [p, n, d] = main_plane_extraction(s{i});
        
        plane.points = s{i}(:, p);
        plane.n = n;
        plane.d = d;
        
        planes = [planes plane];
        ui(p) = [];
        uRest = [uRest ui];
        
        %fig = plot_3Dpoints(plane.points, map(mod(1 + (i-1)*5, length(map)), :), fig);
        
    end
    
    i = i+1;
    
end

i=1;
colorstep = round(length(map)/length(planes));
while(i<=length(planes))
    
    fig = plot_3Dpoints(planes(i).points, map(mod(65 - (i-1)*colorstep, length(map)), :), fig);
    i = i+1;
    
end

fig = plot_3Dpoints(frame.points3D_org(1:3, uRest), 'k', fig);

% max1 = ni(1);
% max2 = ni(2);
% max3 = ni(3);
% max4 = ni(4);
% 
% u1 = find(regionsVec == max1);
% u2 = find(regionsVec == max2);
% u3 = find(regionsVec == max3);
% u4 = find(regionsVec == max4);
% 
% u1 = u1(ismember(u1, frame.usage));
% u2 = u2(ismember(u2, frame.usage));
% u3 = u3(ismember(u3, frame.usage));
% u4 = u4(ismember(u4, frame.usage));
% 
% uRest = frame.usage;
% uRest(ismember(uRest, u1)) = [];
% uRest(ismember(uRest, u2)) = [];
% uRest(ismember(uRest, u3)) = [];
% uRest(ismember(uRest, u4)) = [];
% 
% s1 = frame.points3D_org(1:3, u1);
% [p1, n1, d1] = main_plane_extraction(s1);
% p1Rest = 1:1:length(s1);
% p1Rest(ismember(p1Rest, p1)) = [];
% 
% s2 = frame.points3D_org(1:3, u2);
% [p2, n2, d2] = main_plane_extraction(s2);
% p2Rest = 1:1:length(s2);
% p2Rest(ismember(p2Rest, p2)) = [];
% 
% s3 = frame.points3D_org(1:3, u3);
% [p3, n3, d3] = main_plane_extraction(s3);
% p3Rest = 1:1:length(s3);
% p3Rest(ismember(p3Rest, p3)) = [];
% 
% s4 = frame.points3D_org(1:3, u4);
% [p4, n4, d4] = main_plane_extraction(s4);
% p4Rest = 1:1:length(s4);
% p4Rest(ismember(p4Rest, p4)) = [];

% s4 = frame.points3D_org(1:3, uRest);
% [p4, n4, d4] = main_plane_extraction(s4);
% p4Rest = 1:1:length(s4);
% p4Rest(ismember(p4Rest, p4)) = [];

% s1plane = s1(:, p1);
% s2plane = s2(:, p2);
% s3plane = s3(:, p3);
% s4plane = s4(:, p4);
% s1Rest = s1(:, p1Rest);
% s2Rest = s2(:, p2Rest);
% s3Rest = s3(:, p3Rest);
% s4Rest = s4(:, p4Rest);
% sRest = [s1(:, p1Rest) s2(:, p2Rest) s3(:, p3Rest) s4(:,p4Rest)];
% 
% fig1 = plot_3Dpoints(s1plane, 'r');
% fig1 = plot_3Dpoints(s1Rest, 'k', fig1);
% fig2 = plot_3Dpoints(s2plane, 'g');
% fig2 = plot_3Dpoints(s2Rest, 'k', fig2);
% fig3 = plot_3Dpoints(s3plane, 'b');
% fig3 = plot_3Dpoints(s3Rest, 'k', fig3);
% fig4 = plot_3Dpoints(s4plane, 'y');
% fig4 = plot_3Dpoints(s4Rest, 'k', fig4);
% 
% fig = plot_3Dpoints(s1plane, 'r');
% fig = plot_3Dpoints(s2plane, 'g', fig);
% fig = plot_3Dpoints(s3plane, 'b', fig);
% fig = plot_3Dpoints(s4plane, 'y', fig);
% fig = plot_3Dpoints(sRest, 'k', fig);

% fig = plot_3Dpoints(frame.points3D_org(1:3, u1), 'r');
% fig = plot_3Dpoints(frame.points3D_org(1:3, u2), 'g', fig);
% fig = plot_3Dpoints(frame.points3D_org(1:3, u3), 'b', fig);
% fig = plot_3Dpoints(frame.points3D_org(1:3, uRest), 'k', fig);