function frame = backprojection_fast(fr, camType)
%frame = backprojection_fast(fr, camType)

frame = fr;

xLocal = zeros(camType.height, camType.width);
yLocal = zeros(camType.height, camType.width);
zLocal(1:(camType.height*camType.width)) = camType.focalLength;

dLocal = zeros(1, camType.height*camType.width);
tScale = zeros(1, camType.height*camType.width);

i=2;
while(i<=camType.width)
    xLocal(:,i) = i-1;
    i=i+1;
end

i=2;
while(i<=camType.height)
    yLocal(i,:) = i-1;
    i=i+1;
end

xLocal = reshape(xLocal', 1, camType.width*camType.height);
yLocal = reshape(yLocal', 1, camType.width*camType.height);

xLocal = xLocal - camType.principalPoint(1);
xLocal = camType.pixelWidth*xLocal;
yLocal = yLocal - camType.principalPoint(2);
yLocal = (-1)*camType.pixelHeight*yLocal;

dLocal = sqrt(xLocal.^2 + yLocal.^2 + zLocal.^2);

tScale = frame.distances./dLocal;

x = tScale.*xLocal;
y = tScale.*yLocal;
z = tScale.*zLocal;

frame.points3D = [x;y;z;ones(1,(camType.height*camType.width))];
frame.points3D_org = [x;y;z;ones(1,(camType.height*camType.width))];