function frame = projection(fr, camType)
%frame = projection(fr, camType)

frame = fr;

X = fr.points3D(1,:);
Y = fr.points3D(2,:);
Z = fr.points3D(3,:);

xLocal = zeros(camType.height, camType.width);
yLocal = zeros(camType.height, camType.width);
zLocal(1:(camType.height*camType.width)) = camType.focalLength;

dLocal = zeros(1, camType.height*camType.width);
tScale = zeros(1, camType.height*camType.width);

i=2;
while(i<=camType.width)
    xLocal(:,i) = i-1;
    i=i+1;
end

i=2;
while(i<=camType.height)
    yLocal(i,:) = i-1;
    i=i+1;
end

xLocal = reshape(xLocal', 1, camType.width*camType.height);
yLocal = reshape(yLocal', 1, camType.width*camType.height);

xLocal = xLocal - camType.principalPoint(1);
xLocal = camType.pixelWidth*xLocal;
yLocal = yLocal - camType.principalPoint(2);
yLocal = (-1)*camType.pixelHeight*yLocal;

dLocal = sqrt(xLocal.^2 + yLocal.^2 + zLocal.^2);

tScale = fr.points3D_org(3,:) ./ zLocal;

frame.distances = dLocal .* tScale;