function [newPnts, Rot] = align_pnts2plane(pnts, normal, center)
%% [newPnts, Rot] = align_pnts2plane(pnts, normal, center)

if(size(pnts,1) == 3)
    pnts = [pnts; ones(1,size(pnts,2))];
end
    

%% move points with center to origin
%Tc = eye(4);
%Tc(1:3,4) = -1*center(1:3);
%Pnts_new = Tc * Pnts_new;
%Pnts_new = Pnts-repmat([center(1:3); 0], 1, size(Pnts,2));
T1 = [1 0 0 -center(1); 0 1 0 -center(2); 0 0 1 -center(3); 0 0 0 1];
T2 = [1 0 0 0; 0 1 0 0; 0 0 1 center(3); 0 0 0 1];

%% calculate angles for rotation
angle1 = atan(normal(1)/normal(2));
Rot1 = [cos(angle1) -sin(angle1) 0 0; sin(angle1) cos(angle1) 0 0; 0 0 1 0; 0 0 0 1];
normal_new = Rot1*[normal;1];
angle2 = atan(normal_new(2)/normal(3));
Rot2 = [1 0 0 0; 0 cos(angle2) -sin(angle2) 0; 0 sin(angle2) cos(angle2) 0; 0 0 0 1];

%% transformation matrix
Rot = Rot2*Rot1*T1;


% Rot = [cos(angle1) -sin(angle1) 0 -center(1)*cos(angle1)+center(2)*sin(angle1); ...
%     cos(angle2)*sin(angle1) cos(angle2)*cos(angle1) -sin(angle2) -center(1)*cos(angle2)*sin(angle1)-center(2)*cos(angle2)*cos(angle1)+center(3)*sin(angle2); ...
%     sin(angle2)*sin(angle1) sin(angle2)*cos(angle1) cos(angle2) -center(1)*sin(angle2)*sin(angle1)-center(2)*sin(angle2)*cos(angle1)- center(3)*cos(angle2)+center(3); ...
%     0 0 0 1];
% rotate points in origin


newPnts = Rot * pnts;