function map = generate_colormap(nColor)
% map = generate_colormap(nColor)

map = zeros(nColor, 3);
map(1,:) = [0 0 0.5];

nPerSlot = floor((nColor-1)/5);
rest = mod((nColor-1),5);

mapEntry = 2;

%+z:
step = 0.5 / nPerSlot;
i=1;
while(i<=nPerSlot)
    map(mapEntry,:) = map(mapEntry-1,:) + [0 0 step];
    i = i+1;
    mapEntry = mapEntry+1;
end

%+y:
step = 1 / nPerSlot;
i=1;
while(i<=nPerSlot)
    map(mapEntry,:) = map(mapEntry-1,:) + [0 step 0];
    i = i+1;
    mapEntry = mapEntry+1;
end

%+x-z:
step = 1 / (nPerSlot + rest);
i=1;
while(i<=(nPerSlot + rest))
    map(mapEntry,:) = map(mapEntry-1,:) + [step 0 -step];
    i = i+1;
    mapEntry = mapEntry+1;
end

%-y:
step = 1 / nPerSlot;
i=1;
while(i<=nPerSlot)
    map(mapEntry,:) = map(mapEntry-1,:) - [0 step 0];
    i = i+1;
    mapEntry = mapEntry+1;
end

%-x:
step = 0.5 / nPerSlot;
i=1;
while(i<=nPerSlot)
    map(mapEntry,:) = map(mapEntry-1,:) - [step 0 0];
    i = i+1;
    mapEntry = mapEntry+1;
end

map(find(map > 1)) = 1;
map(find(map < 0)) = 0;
